                      Computer Science 481/681
                         Quiz D           Name _______________________

1. TCP's timeout and retransmission procedure is driven by

   a. A timer exit that is activated    b. A timer exit that is created
      at fixed 200 msec intervals.         for each pkt transmitted and
                                           fires at the end of the current
                                           RTO.
   c. A timer exit that is triggered
      at fixed 500 msec intervals.

2. TCP's timeout and retransmission procedure

   a. Adds 1 second to the timeout      b. Doubles the timeout delay
      delay each time the same packet      up to a maximum of 64 secs.
      times out up to a limit of 6 sec.

   c. Adds 1 second but with no upper   d. Doubles the interval with
      bound.                               no upper bound.

3. TCP's retransmission strategy

   a. persists in retrying until the    b. Retries until the timeout
      application is terminated.           delay exceeds 1 minute and
                                           then gives up.

   c. Retries a maximum of 2 times and  d. Retries a maximum of 12 times and
      then resets the connection.          then resets the connection.

4. The main problem of the original TCP estimator of round trip transit
   time was that it:

   a. was not adequately responsive     b. Consistently overestimated
      to load variations.                  steady state delays.

   c. Consistently underestimated       d. Completely ceased to function
      steady state delays.                 at high loads.

5. Karn's improvment to Jacobson's new algorithm for computing R and
   RTO was to:

   a. Multiply the variance             b. Ignore ACK's for retransmitted
      computed by Jacobson by 4.           packets in computing R and RTO.

   c. Change the resolution of the      d. Only time one outstanding packet
      timer used in the computation.       at a time rather than trying to
                                           time all of them.

6. In the "slow start" congestion avoidance algorithm the size of the
   congestion window "cwnd" is initially set to

   a. 1 byte.                           b. 1 * the offered window

   b. 1 * the max segment length.       d. 64K.

7. When slow start is being performed, each time a full congestion window
   of segments is sent and acked, the size of cwnd typically

   a. Increases by 1 byte               b. Increases by 1 * MSL

   c. Doubles                           d. Stays the same

8. When slow-start and congestion-avoidance are performed together
   the size of cwnd typically

   a. Increases at the same rate in     b. Increases faster in slow start
      both the slow start and the          than in congestion avoidance.
      congestion avoidance phases.

   c. Increases faster in congestion    d. Stays the same in both
      avoidance than in slow start.

9. After a packet timeout and retransmission has occurred, the value
   "ssthresh"  signifies:

   a. The cwnd size at which the        b. The cwnd size at which the
      changeover from slow start to        changeover from congestion
      congestion avoidance will occur.     avoidance to slow start will
                                           occur.

   c. The maximum size of cwnd that     d. The minimum cwnd size allowed
      will be allowed on this connection   for the next hour.
      for the next hour.

10. The function of the TCP persist timer is to:

    a. Ensure that the TCP at the other  b. Ensure that a packet that
       end has not crashed when no data     has timed out is eventually
       have been exchanged for a long       delivered.
       time.

    c. Recover from lost window size     d. Recover from half-closed
       update packets.                      sessions.

11. Suppose that two TCP's are connected by a transcontinental link
    that has supports a transmission rate of 100 MegaBytes/second
    but has a two way round trip transit time of 50 millisecs.  What
    is the maxium effective throughput (in bytes per second)
    on this channel if the receiver offers a window of 50KBytes.

